import { FormElementType, pluginConstructor } from './types';
export declare const PACKAGE_LICENSE_URL = "https://formsjs.io/documentation/v1/licensing";
export declare const licensePlateClass = "#";
export declare const licensePlateStyle = "position: fixed !important; font-weight: bold; font-size: .8rem;  bottom: 1rem !important;  left: 1rem !important;  background: #fff;  border: 2px solid red;  padding: .5rem;  border-radius: 0.15rem;  z-index: 99999 !important;  display: inline-flex !important;  align-items: center;  color: red;  text-decoration: none;  transition: 0.2s linear;";
export declare const STRING_CONDITION_SPLIT = ";";
export declare const STRING_CONDITION_VALUE_SPLIT = ":";
export declare const STRING_CONDITION_DATE_IDENTIFIER = "date!";
export declare const FORM_CLASS_DEFAULT = "formsjs-form";
export declare const BUTTON_CONTAINER_CLASS_DEFAULT = "form-button-container";
export declare const GROUP_CONTAINER_CLASS_DEFAULT = "form-group-container";
export declare const GROUP_CLASS_DEFAULT = "form-group";
export declare const GROUP_LABEL_CLASS_DEFAULT = "form-group-label";
export declare const BUTTON_CLASS_DEFAULT = "btn form-button";
export declare const INPUT_CLASS_DEFAULT = "form-input";
export declare const FIELD_CONTAINER_CLASS_DEFAULT = "form-field-container";
export declare const FIELD_CLASS_DEFAULT = "form-field";
export declare const LABEL_CLASS_DEFAULT = "form-field-label";
export declare const VALIDATION_CLASS_DEFAULT = "form-field-validation";
export declare const FORM_ERROR_CLASS_DEFAULT = "form-error";
export declare const FIELD_DISABLED_CLASS_DEFAULT = "field-disabled";
export declare const FIELD_REQUIRED_CLASS_DEFAULT = "field-required";
export declare const CHECKBOX_CLASS_DEFAULT = "form-input-checkbox";
export declare const TOGGLE_CLASS_DEFAULT = "is-toggle";
export declare const TOGGLE_SLIDER_CLASS_DEFAULT = "toggle-slider";
export declare const COLOR_CLASS_DEFAULT = "form-input-color";
export declare const RADIO_CLASS_DEFAULT = "form-input-radio";
export declare const RANGE_CLASS_DEFAULT = "form-input-range";
export declare const RANGE_MIN_CLASS_DEFAULT = "form-input-range-min";
export declare const RANGE_MAX_CLASS_DEFAULT = "form-input-range-max";
export declare const RANGE_VALUE_CLASS_DEFAULT = "form-input-range-value";
export declare const SELECT_CLASS_DEFAULT = "form-input-select";
export declare const STATIC_CLASS_DEFAULT = "form-input-static";
export declare const DEFAULT_REQUIRED_VALIDATION_MESSAGE = "This field is required";
export declare const INVALID_EMAIL_VALIDATION_MESSAGE = "Not a valid email address";
export declare const INVALID_PHONE_VALIDATION_MESSAGE = "Not a valid telephone number";
export declare const INVALID_URL_VALIDATION_MESSAGE = "Not a valid url address";
export declare const BIGGER_THAN_VALIDATION_MESSAGE = "The value should be bigger than ";
export declare const LESS_THAN_VALIDATION_MESSAGE = "The value should be less than ";
export declare const DIV_ELEMENT = "div";
export declare const SPAN_ELEMENT = "span";
export declare const LABEL_ELEMENT = "label";
export declare const FORM_ELEMENT = "form";
export declare const LINK_ELEMENT = "a";
export declare const BUTTON_ELEMENT = "button";
export declare const INPUT_ELEMENT = "input";
export declare const PARAGRAPH_ELEMENT = "p";
export declare const H3_ELEMENT = "h3";
export declare const OUTPUT_ELEMENT = "output";
export declare const SELECT_ELEMENT = "select";
export declare const OPTION_ELEMENT = "option";
export declare const TEXTAREA_ELEMENT = "textarea";
export declare const CONTAINER_DEFINITION = "_container";
export declare const LABEL_DEFINITION = "_label";
export declare const VALIDATION_DEFINITION = "_validation";
export declare const GROUP_CONTAINER_DEFINITION = "_group_container";
export declare const FORMSJS_KEY_DEFINITION = "__formsjs_";
export declare const FIELD_KEY_DEFINITION = "_field_";
export declare const MIN_DEFINITION = "_min";
export declare const MAX_DEFINITION = "_max";
export declare const VALUE_DEFINITION = "_value";
export declare const ID_ATTRIBUTE = "id";
export declare const ACTION_ATTRIBUTE = "action";
export declare const METHOD_ATTRIBUTE = "method";
export declare const SUBMIT_ATTRIBUTE = "submit";
export declare const RESET_ATTRIBUTE = "reset";
export declare const TYPE_ATTRIBUTE = "type";
export declare const HREF_ATTRIBUTE = "href";
export declare const CLICK_ATTRIBUTE = "click";
export declare const INPUT_ATTRIBUTE = "input";
export declare const NAME_ATTRIBUTE = "name";
export declare const PLACEHOLDER_ATTRIBUTE = "placeholder";
export declare const FOR_ATTRIBUTE = "for";
export declare const ARIA_INVALID_ATTRIBUTE = "aria-invalid";
export declare const ARIA_DESCRIBEDBY_ATTRIBUTE = "aria-describedby";
export declare const DISABLED_ATTRIBUTE = "disabled";
export declare const REQUIRED_ATTRIBUTE = "required";
export declare const CHECKED_ATTRIBUTE = "checked";
export declare const CHANGE_ATTRIBUTE = "change";
export declare const MULTIPLE_ATTRIBUTE = "multiple";
export declare const ACCEPT_ATTRIBUTE = "accept";
export declare const MIN_ATTRIBUTE = "min";
export declare const MAX_ATTRIBUTE = "max";
export declare const STEP_ATTRIBUTE = "step";
export declare const VALUE_ATTRIBUTE = "value";
export declare const SELECTED_ATTRIBUTE = "selected";
export declare const ROWS_ATTRIBUTE = "rows";
export declare const GROUP_TYPE_GROUP = "group";
export declare const BUTTON_TYPE_BUTTON = "button";
export declare const FIELD_TYPE_CHECKBOX = "checkbox";
export declare const FIELD_TYPE_COLOR = "color";
export declare const FIELD_TYPE_DATE = "date";
export declare const FIELD_TYPE_DATETIME = "datetime";
export declare const FIELD_TYPE_EMAIL = "email";
export declare const FIELD_TYPE_FILE = "file";
export declare const FIELD_TYPE_HIDDEN = "hidden";
export declare const FIELD_TYPE_NUMBER = "number";
export declare const FIELD_TYPE_PASSWORD = "password";
export declare const FIELD_TYPE_RADIO = "radio";
export declare const FIELD_TYPE_RANGE = "range";
export declare const FIELD_TYPE_SELECT = "select";
export declare const FIELD_TYPE_STATIC = "static";
export declare const FIELD_TYPE_TEL = "tel";
export declare const FIELD_TYPE_TEXTAREA = "textarea";
export declare const FIELD_TYPE_TEXT = "text";
export declare const FIELD_TYPE_TIME = "time";
export declare const FIELD_TYPE_URL = "url";
export declare const FIELD_TYPE_WEEK = "week";
export declare const FIELD_TYPE_DATERANGE = "daterange";
export declare const fields: string[];
export declare const groups: string[];
export declare const buttons: string[];
export declare const formElements: string[];
export declare const constructorTypes: {
    field: string;
    group: string;
    button: string;
};
export declare const elementConstructors: {
    [key in FormElementType]?: pluginConstructor;
};
export declare const OS_LICENSE_KEYS: string[];
export declare const VALID_LICENSE_TEXT = "forms.js license key is valid";
export declare const INVALID_LICENSE_TEXT = "forms.js license key is invalid";
export declare const OUTDATED_LICENSE_TEXT = "forms.js license key is outdated";
export declare const INVALID_CONSOLE_TEXT = "forms.js license key is invalid, please use a valid license key.";
export declare const OUTDATED_CONSOLE_TEXT = "forms.js license key is outdated, please update your license key.";
export declare const UPGRADE_WINDOW: number;
export declare const LICENSE_STATE: {
    VALID: number;
    OUTDATED: number;
    INVALID: number;
};
export declare const RELEASE_DATE = "2024-02-25";
export declare const registerConstructor: (type: string, constructor: pluginConstructor, constructorT: string, licensed?: boolean) => void;
