"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ColorField = void 0;
const constants_1 = require("../constants");
const field_1 = require("../field");
class ColorField extends field_1.Field {
    constructor(parent, form, options) {
        super(parent, form, options);
        this.options = {
            id: '',
            type: constants_1.FIELD_TYPE_COLOR,
            required: false,
            validation: (value, data, required) => {
                if (required && !value)
                    return constants_1.DEFAULT_REQUIRED_VALIDATION_MESSAGE;
                return true;
            },
            default: null,
            className: constants_1.COLOR_CLASS_DEFAULT,
        };
        this.initializeOptions(options);
        this.onGui();
        this.initialize();
    }
    bindChange() {
        if (this.inputElement)
            this.inputElement.addEventListener(constants_1.CHANGE_ATTRIBUTE, (event) => {
                this.change(event);
            });
    }
    getValue() {
        return this._value;
    }
}
exports.ColorField = ColorField;
