"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DatetimeField = void 0;
const flatpickerNamespace = __importStar(require("flatpickr"));
const flatpickr = flatpickerNamespace.default;
const field_1 = require("../field");
const constants_1 = require("../constants");
class DatetimeField extends field_1.Field {
    constructor(parent, form, options) {
        super(parent, form, options);
        this.options = {
            id: '',
            type: constants_1.FIELD_TYPE_DATETIME,
            required: false,
            validation: (value, data, required) => {
                if (required && !value)
                    return constants_1.DEFAULT_REQUIRED_VALIDATION_MESSAGE;
                return true;
            },
            className: constants_1.INPUT_CLASS_DEFAULT,
            enhance: true,
            options: {
                altInput: true,
                enableTime: true,
            },
        };
        this._flatpickr = null;
        this.initializeOptions(options);
        this.onGui();
        this.initialize();
    }
    initialize() {
        return __awaiter(this, void 0, void 0, function* () {
            this.load();
            this.update();
            this.initFlatpickr();
            this.bindChange();
        });
    }
    getFlatpickr() {
        return this._flatpickr;
    }
    initFlatpickr() {
        if (this.inputElement && this.options.enhance)
            this._flatpickr = flatpickr(this.inputElement, this.options.options || {});
    }
    bindChange() {
        if (this.inputElement)
            this.inputElement.addEventListener(constants_1.CHANGE_ATTRIBUTE, (event) => {
                this.change(event);
            });
    }
    createInputElement() {
        this.inputElement = document.createElement(constants_1.INPUT_ELEMENT);
        this.inputElement.setAttribute(constants_1.ID_ATTRIBUTE, this.getId());
        this.inputElement.setAttribute(constants_1.NAME_ATTRIBUTE, this.options.name || this.getId());
        this.inputElement.setAttribute(constants_1.TYPE_ATTRIBUTE, this.options.enhance ? 'text' : 'datetime-local');
        this.inputElement.className = this.options.className;
        if (this.options.placeholder)
            this.inputElement.setAttribute(constants_1.PLACEHOLDER_ATTRIBUTE, this.options.placeholder);
    }
    getValue() {
        return this._value;
    }
}
exports.DatetimeField = DatetimeField;
