"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.EmailField = void 0;
const constants_1 = require("../constants");
const field_1 = require("../field");
class EmailField extends field_1.Field {
    constructor(parent, form, options) {
        super(parent, form, options);
        this.options = {
            id: '',
            type: constants_1.FIELD_TYPE_EMAIL,
            required: false,
            validation: (value, data, required) => {
                if (required && !value)
                    return constants_1.DEFAULT_REQUIRED_VALIDATION_MESSAGE;
                if (value && typeof value === 'string' && !value.match(this.mailFormat))
                    return constants_1.INVALID_EMAIL_VALIDATION_MESSAGE;
                return true;
            },
            default: '',
            className: constants_1.INPUT_CLASS_DEFAULT,
        };
        this.mailFormat = /^[a-zA-Z0-9._%+-]+@[a-zA-Z0-9.-]+\.[a-zA-Z]{2,}$/;
        this.initializeOptions(options);
        this.onGui();
        this.initialize();
    }
    getValue() {
        return this._value;
    }
}
exports.EmailField = EmailField;
