import { Form } from '../form';
import { StaticFieldOptions } from '../interfaces';
export declare class StaticField {
    options: StaticFieldOptions;
    staticElement: HTMLElement | null;
    containerElement: HTMLElement | null;
    private _id;
    private _parent;
    private _form;
    private _isMounted;
    private _isVisible;
    private _saveKey;
    private _value;
    private _type;
    private _parsedConditions;
    constructor(parent: HTMLElement, form: Form, options: StaticFieldOptions);
    initializeOptions(options: StaticFieldOptions): void;
    initialize(): Promise<void>;
    private parseStringConditions;
    getValue(): string | null;
    getId(): string;
    getSaveKey(): string;
    getType(): string;
    getVisibility(): boolean;
    getForm(): Form;
    setTemplate(template: string, save?: boolean): void;
    createContainerElement(): void;
    createStaticElement(): void;
    onGui(): void;
    private mount;
    private unmount;
    destroy(): void;
    handleVisibility(): void;
    save(): void;
    load(): void;
    reset(): Promise<void>;
    update(): Promise<void>;
    private updateVisibilityBasedOnConditions;
}
