"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TelField = void 0;
const constants_1 = require("../constants");
const field_1 = require("../field");
class TelField extends field_1.Field {
    constructor(parent, form, options) {
        super(parent, form, options);
        this.options = {
            id: '',
            type: constants_1.FIELD_TYPE_TEL,
            required: false,
            validation: (value, data, required) => {
                if (required && !value)
                    return constants_1.DEFAULT_REQUIRED_VALIDATION_MESSAGE;
                if (value && typeof value === 'string' && !value.match(this.telFormat))
                    return constants_1.INVALID_PHONE_VALIDATION_MESSAGE;
                return true;
            },
            default: null,
            className: constants_1.INPUT_CLASS_DEFAULT,
        };
        this.telFormat = /^\+[1-9]\d{1,14}$/;
        this.initializeOptions(options);
        this.onGui();
        this.initialize();
    }
    getValue() {
        return this._value;
    }
}
exports.TelField = TelField;
