"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TextareaField = void 0;
const constants_1 = require("../constants");
const field_1 = require("../field");
class TextareaField extends field_1.Field {
    createInputElement() {
        this.inputElement = document.createElement(constants_1.TEXTAREA_ELEMENT);
        this.inputElement.setAttribute(constants_1.ID_ATTRIBUTE, this.getId());
        this.inputElement.setAttribute(constants_1.NAME_ATTRIBUTE, this.options.name || this.getId());
        if (this.options.rows)
            this.inputElement.setAttribute(constants_1.ROWS_ATTRIBUTE, String(this.options.rows));
        this.inputElement.setAttribute(constants_1.TYPE_ATTRIBUTE, this.getType());
        this.inputElement.className = this.options.className;
        if (this.options.placeholder)
            this.inputElement.setAttribute(constants_1.PLACEHOLDER_ATTRIBUTE, this.options.placeholder);
    }
    constructor(parent, form, options) {
        super(parent, form, options);
        this.options = {
            id: '',
            type: constants_1.FIELD_TYPE_TEXTAREA,
            required: false,
            validation: (value, data, required) => {
                if (required && !value)
                    return constants_1.DEFAULT_REQUIRED_VALIDATION_MESSAGE;
                return true;
            },
            className: constants_1.INPUT_CLASS_DEFAULT,
            rows: 5,
        };
        this.inputElement = null;
        this.initializeOptions(options);
        this.onGui();
        this.initialize();
    }
    getValue() {
        return this._value;
    }
}
exports.TextareaField = TextareaField;
