"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.overwriteDefaults = exports.parseConditionString = exports.evaluateParsedConditions = exports.FIELD_TYPE_DATERANGE = exports.FIELD_TYPE_WEEK = exports.FIELD_TYPE_URL = exports.FIELD_TYPE_TIME = exports.FIELD_TYPE_TEXT = exports.FIELD_TYPE_TEXTAREA = exports.FIELD_TYPE_TEL = exports.FIELD_TYPE_STATIC = exports.FIELD_TYPE_SELECT = exports.FIELD_TYPE_RANGE = exports.FIELD_TYPE_RADIO = exports.FIELD_TYPE_PASSWORD = exports.FIELD_TYPE_NUMBER = exports.FIELD_TYPE_HIDDEN = exports.FIELD_TYPE_FILE = exports.FIELD_TYPE_EMAIL = exports.FIELD_TYPE_DATETIME = exports.FIELD_TYPE_DATE = exports.FIELD_TYPE_COLOR = exports.FIELD_TYPE_CHECKBOX = exports.BUTTON_TYPE_BUTTON = exports.GROUP_TYPE_GROUP = exports.registerConstructor = exports.constructorTypes = exports.groups = exports.buttons = exports.fields = exports.Field = exports.generateFieldSaveKey = exports.useLicensedFetures = exports.extractFieldsFromSchema = exports.unmountElement = exports.mountElement = exports.setLicenseKey = exports.Button = exports.Form = exports.usePlugin = void 0;
const radioField_1 = require("./fields/radioField");
const datetimeField_1 = require("./fields/datetimeField");
const button_1 = require("./button");
const constants_1 = require("./constants");
const index_1 = require("./fields/index");
const group_1 = require("./group");
(0, constants_1.registerConstructor)(constants_1.GROUP_TYPE_GROUP, group_1.Group, constants_1.constructorTypes.group);
(0, constants_1.registerConstructor)(constants_1.BUTTON_TYPE_BUTTON, button_1.Button, constants_1.constructorTypes.button);
(0, constants_1.registerConstructor)(constants_1.FIELD_TYPE_CHECKBOX, index_1.CheckboxField, constants_1.constructorTypes.field);
(0, constants_1.registerConstructor)(constants_1.FIELD_TYPE_COLOR, index_1.ColorField, constants_1.constructorTypes.field);
(0, constants_1.registerConstructor)(constants_1.FIELD_TYPE_DATE, index_1.DateField, constants_1.constructorTypes.field);
(0, constants_1.registerConstructor)(constants_1.FIELD_TYPE_DATETIME, datetimeField_1.DatetimeField, constants_1.constructorTypes.field);
(0, constants_1.registerConstructor)(constants_1.FIELD_TYPE_EMAIL, index_1.EmailField, constants_1.constructorTypes.field);
(0, constants_1.registerConstructor)(constants_1.FIELD_TYPE_FILE, index_1.FileField, constants_1.constructorTypes.field);
(0, constants_1.registerConstructor)(constants_1.FIELD_TYPE_HIDDEN, index_1.HiddenField, constants_1.constructorTypes.field);
(0, constants_1.registerConstructor)(constants_1.FIELD_TYPE_NUMBER, index_1.NumberField, constants_1.constructorTypes.field);
(0, constants_1.registerConstructor)(constants_1.FIELD_TYPE_PASSWORD, index_1.PasswordField, constants_1.constructorTypes.field);
(0, constants_1.registerConstructor)(constants_1.FIELD_TYPE_RADIO, radioField_1.RadioField, constants_1.constructorTypes.field);
(0, constants_1.registerConstructor)(constants_1.FIELD_TYPE_RANGE, index_1.RangeField, constants_1.constructorTypes.field);
(0, constants_1.registerConstructor)(constants_1.FIELD_TYPE_SELECT, index_1.SelectField, constants_1.constructorTypes.field);
(0, constants_1.registerConstructor)(constants_1.FIELD_TYPE_STATIC, index_1.StaticField, constants_1.constructorTypes.field);
(0, constants_1.registerConstructor)(constants_1.FIELD_TYPE_TEL, index_1.TelField, constants_1.constructorTypes.field);
(0, constants_1.registerConstructor)(constants_1.FIELD_TYPE_TEXTAREA, index_1.TextareaField, constants_1.constructorTypes.field);
(0, constants_1.registerConstructor)(constants_1.FIELD_TYPE_TEXT, index_1.TextField, constants_1.constructorTypes.field);
(0, constants_1.registerConstructor)(constants_1.FIELD_TYPE_TIME, index_1.TimeField, constants_1.constructorTypes.field);
(0, constants_1.registerConstructor)(constants_1.FIELD_TYPE_URL, index_1.UrlField, constants_1.constructorTypes.field);
(0, constants_1.registerConstructor)(constants_1.FIELD_TYPE_WEEK, index_1.WeekField, constants_1.constructorTypes.field);
const usePlugin = (settings) => {
    var _a;
    if (Array.isArray(settings)) {
        settings.forEach((s) => {
            var _a;
            (0, constants_1.registerConstructor)(s.type, s.constructor, s.constructorType, (_a = s.licensed) !== null && _a !== void 0 ? _a : false);
        });
    }
    else {
        (0, constants_1.registerConstructor)(settings.type, settings.constructor, settings.constructorType, (_a = settings.licensed) !== null && _a !== void 0 ? _a : false);
    }
};
exports.usePlugin = usePlugin;
var form_1 = require("./form");
Object.defineProperty(exports, "Form", { enumerable: true, get: function () { return form_1.Form; } });
var button_2 = require("./button");
Object.defineProperty(exports, "Button", { enumerable: true, get: function () { return button_2.Button; } });
var utils_1 = require("./utils");
Object.defineProperty(exports, "setLicenseKey", { enumerable: true, get: function () { return utils_1.setLicenseKey; } });
Object.defineProperty(exports, "mountElement", { enumerable: true, get: function () { return utils_1.mountElement; } });
Object.defineProperty(exports, "unmountElement", { enumerable: true, get: function () { return utils_1.unmountElement; } });
Object.defineProperty(exports, "extractFieldsFromSchema", { enumerable: true, get: function () { return utils_1.extractFieldsFromSchema; } });
Object.defineProperty(exports, "useLicensedFetures", { enumerable: true, get: function () { return utils_1.useLicensedFetures; } });
Object.defineProperty(exports, "generateFieldSaveKey", { enumerable: true, get: function () { return utils_1.generateFieldSaveKey; } });
var field_1 = require("./field");
Object.defineProperty(exports, "Field", { enumerable: true, get: function () { return field_1.Field; } });
var constants_2 = require("./constants");
Object.defineProperty(exports, "fields", { enumerable: true, get: function () { return constants_2.fields; } });
Object.defineProperty(exports, "buttons", { enumerable: true, get: function () { return constants_2.buttons; } });
Object.defineProperty(exports, "groups", { enumerable: true, get: function () { return constants_2.groups; } });
Object.defineProperty(exports, "constructorTypes", { enumerable: true, get: function () { return constants_2.constructorTypes; } });
Object.defineProperty(exports, "registerConstructor", { enumerable: true, get: function () { return constants_2.registerConstructor; } });
Object.defineProperty(exports, "GROUP_TYPE_GROUP", { enumerable: true, get: function () { return constants_2.GROUP_TYPE_GROUP; } });
Object.defineProperty(exports, "BUTTON_TYPE_BUTTON", { enumerable: true, get: function () { return constants_2.BUTTON_TYPE_BUTTON; } });
Object.defineProperty(exports, "FIELD_TYPE_CHECKBOX", { enumerable: true, get: function () { return constants_2.FIELD_TYPE_CHECKBOX; } });
Object.defineProperty(exports, "FIELD_TYPE_COLOR", { enumerable: true, get: function () { return constants_2.FIELD_TYPE_COLOR; } });
Object.defineProperty(exports, "FIELD_TYPE_DATE", { enumerable: true, get: function () { return constants_2.FIELD_TYPE_DATE; } });
Object.defineProperty(exports, "FIELD_TYPE_DATETIME", { enumerable: true, get: function () { return constants_2.FIELD_TYPE_DATETIME; } });
Object.defineProperty(exports, "FIELD_TYPE_EMAIL", { enumerable: true, get: function () { return constants_2.FIELD_TYPE_EMAIL; } });
Object.defineProperty(exports, "FIELD_TYPE_FILE", { enumerable: true, get: function () { return constants_2.FIELD_TYPE_FILE; } });
Object.defineProperty(exports, "FIELD_TYPE_HIDDEN", { enumerable: true, get: function () { return constants_2.FIELD_TYPE_HIDDEN; } });
Object.defineProperty(exports, "FIELD_TYPE_NUMBER", { enumerable: true, get: function () { return constants_2.FIELD_TYPE_NUMBER; } });
Object.defineProperty(exports, "FIELD_TYPE_PASSWORD", { enumerable: true, get: function () { return constants_2.FIELD_TYPE_PASSWORD; } });
Object.defineProperty(exports, "FIELD_TYPE_RADIO", { enumerable: true, get: function () { return constants_2.FIELD_TYPE_RADIO; } });
Object.defineProperty(exports, "FIELD_TYPE_RANGE", { enumerable: true, get: function () { return constants_2.FIELD_TYPE_RANGE; } });
Object.defineProperty(exports, "FIELD_TYPE_SELECT", { enumerable: true, get: function () { return constants_2.FIELD_TYPE_SELECT; } });
Object.defineProperty(exports, "FIELD_TYPE_STATIC", { enumerable: true, get: function () { return constants_2.FIELD_TYPE_STATIC; } });
Object.defineProperty(exports, "FIELD_TYPE_TEL", { enumerable: true, get: function () { return constants_2.FIELD_TYPE_TEL; } });
Object.defineProperty(exports, "FIELD_TYPE_TEXTAREA", { enumerable: true, get: function () { return constants_2.FIELD_TYPE_TEXTAREA; } });
Object.defineProperty(exports, "FIELD_TYPE_TEXT", { enumerable: true, get: function () { return constants_2.FIELD_TYPE_TEXT; } });
Object.defineProperty(exports, "FIELD_TYPE_TIME", { enumerable: true, get: function () { return constants_2.FIELD_TYPE_TIME; } });
Object.defineProperty(exports, "FIELD_TYPE_URL", { enumerable: true, get: function () { return constants_2.FIELD_TYPE_URL; } });
Object.defineProperty(exports, "FIELD_TYPE_WEEK", { enumerable: true, get: function () { return constants_2.FIELD_TYPE_WEEK; } });
Object.defineProperty(exports, "FIELD_TYPE_DATERANGE", { enumerable: true, get: function () { return constants_2.FIELD_TYPE_DATERANGE; } });
var utils_2 = require("./utils");
Object.defineProperty(exports, "evaluateParsedConditions", { enumerable: true, get: function () { return utils_2.evaluateParsedConditions; } });
Object.defineProperty(exports, "parseConditionString", { enumerable: true, get: function () { return utils_2.parseConditionString; } });
Object.defineProperty(exports, "overwriteDefaults", { enumerable: true, get: function () { return utils_2.overwriteDefaults; } });
