import { FieldOptions } from './interfaces';
import { Schema, FormData, ParsedCondition, Operator, FieldValue } from './types';
export declare const debounce: (callback: (...args: any[]) => void, wait: number, context: any) => () => void;
export declare const mountElement: (element: HTMLElement, parent: HTMLElement) => void;
export declare const unmountElement: (element: HTMLElement) => void;
export declare const objectToFormData: (obj: any, form?: FormData, namespace?: string) => FormData;
export declare const isField: (type: string) => boolean;
export declare const isGroup: (type: string) => boolean;
export declare const isButton: (type: string) => boolean;
export declare const getFormElementType: (type: string) => string | null;
export declare const extractFieldsFromSchema: (schema: Schema) => string[];
export declare const createWrapper: (parent: HTMLElement) => HTMLElement;
export declare const transformFieldName: (parentId: string, key: string, id: string) => string;
export declare const generateFieldSaveKey: (formId: string, id: string) => string;
export declare const processLicenseKey: () => number;
export declare const setLicenseKey: (key: string) => void;
export declare const getLicenseText: (license: number) => string;
export declare const handleInvalidLicenseLog: (license: number) => void;
export declare const usesLicensedFetures: () => boolean;
export declare const useLicensedFetures: () => void;
export declare const parseConditionString: (conditionStr: string) => {
    conditions: {
        left: string;
        operator: Operator;
        right: any;
        isDate: boolean;
    }[][];
    returnValue: string;
}[];
export declare const evaluateParsedConditions: (parsedConditions: ParsedCondition[], data: FormData, value?: FieldValue | null, required?: boolean | null, def?: boolean) => boolean | string;
export declare const compareValues: (operator: Operator, a: any, b: any) => boolean;
export declare const isJson: (str: string) => boolean;
export declare const overwriteDefaults: (type: string, defaults: FieldOptions) => void;
export declare const getOverwritenDefaults: (type: string, defaults: FieldOptions) => FieldOptions;
