import { CHANGE_ATTRIBUTE, COLOR_CLASS_DEFAULT, DEFAULT_REQUIRED_VALIDATION_MESSAGE, FIELD_TYPE_COLOR, } from '../constants';
import { Field } from '../field';
export class ColorField extends Field {
    options = {
        id: '',
        type: FIELD_TYPE_COLOR,
        required: false,
        validation: (value, data, required) => {
            if (required && !value)
                return DEFAULT_REQUIRED_VALIDATION_MESSAGE;
            return true;
        },
        default: null,
        className: COLOR_CLASS_DEFAULT,
    };
    constructor(parent, form, options) {
        super(parent, form, options);
        this.initializeOptions(options);
        this.onGui();
        this.initialize();
    }
    bindChange() {
        if (this.inputElement)
            this.inputElement.addEventListener(CHANGE_ATTRIBUTE, (event) => {
                this.change(event);
            });
    }
    getValue() {
        return this._value;
    }
}
