import { DEFAULT_REQUIRED_VALIDATION_MESSAGE, FIELD_TYPE_EMAIL, INPUT_CLASS_DEFAULT, INVALID_EMAIL_VALIDATION_MESSAGE, } from '../constants';
import { Field } from '../field';
export class EmailField extends Field {
    options = {
        id: '',
        type: FIELD_TYPE_EMAIL,
        required: false,
        validation: (value, data, required) => {
            if (required && !value)
                return DEFAULT_REQUIRED_VALIDATION_MESSAGE;
            if (value && typeof value === 'string' && !value.match(this.mailFormat))
                return INVALID_EMAIL_VALIDATION_MESSAGE;
            return true;
        },
        default: '',
        className: INPUT_CLASS_DEFAULT,
    };
    mailFormat = /^[a-zA-Z0-9._%+-]+@[a-zA-Z0-9.-]+\.[a-zA-Z]{2,}$/;
    constructor(parent, form, options) {
        super(parent, form, options);
        this.initializeOptions(options);
        this.onGui();
        this.initialize();
    }
    getValue() {
        return this._value;
    }
}
