import { DEFAULT_REQUIRED_VALIDATION_MESSAGE, FIELD_TYPE_TEL, INPUT_CLASS_DEFAULT, INVALID_PHONE_VALIDATION_MESSAGE, } from '../constants';
import { Field } from '../field';
export class TelField extends Field {
    options = {
        id: '',
        type: FIELD_TYPE_TEL,
        required: false,
        validation: (value, data, required) => {
            if (required && !value)
                return DEFAULT_REQUIRED_VALIDATION_MESSAGE;
            if (value && typeof value === 'string' && !value.match(this.telFormat))
                return INVALID_PHONE_VALIDATION_MESSAGE;
            return true;
        },
        default: null,
        className: INPUT_CLASS_DEFAULT,
    };
    telFormat = /^\+[1-9]\d{1,14}$/;
    constructor(parent, form, options) {
        super(parent, form, options);
        this.initializeOptions(options);
        this.onGui();
        this.initialize();
    }
    getValue() {
        return this._value;
    }
}
